local desiredFPS
local nextTime
local windowW, windowH
local canvas

function love.load()
	math.randomseed(os.time())
	desiredFPS = 100
	nextTime = love.timer.getTime()
	windowW, windowH = love.window.getWidth(), love.window.getHeight()
	canvas = love.graphics.newCanvas(windowW, windowH)
end

function love.update(dt)
	nextTime = nextTime + 1/desiredFPS
end

function love.draw()
	love.graphics.setCanvas(canvas)
		-- draw 100 random points
		for point = 1,100 do
			love.graphics.setColor(math.random(0, 255), math.random(0, 255), math.random(0, 255), 255)
			love.graphics.point(math.random(0, windowW - 1), math.random(0, windowH - 1))
		end
	love.graphics.setCanvas()
	
	love.graphics.draw(canvas)
	
	drawText("FPS: " .. love.timer.getFPS(), 0, 0)
	
	local currentTime = love.timer.getTime()
	if nextTime <= currentTime then
		nextTime = currentTime
		return
	end
	love.timer.sleep(nextTime - currentTime)
end


function drawText(text, x, y)
	r, g, b, a = love.graphics.getColor()
	love.graphics.setColor(255, 255, 255, 255)
	love.graphics.print(text, x, y)
	love.graphics.setColor(r, g, b, a)
end